#include "mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
{
    setSurfaceType(QWindow::OpenGLSurface);
    QSurfaceFormat format;
    format.setProfile(QSurfaceFormat::CompatibilityProfile);
    format.setVersion(2, 1);
    setFormat(format);
    context = new QOpenGLContext;
    context->setFormat(format);
    context->create();
    context->makeCurrent(this);
    openGLFunctions = context->functions();
}

MainWindow::~MainWindow()
{
}

void MainWindow::initializeGL()
{
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_CULL_FACE);
    glViewport(0, 0, this->width(), this->height());

    double aspectratio = double(this->width()) / double(this->height());
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-aspectratio, aspectratio, -1, 1, nearVal, farVal);
}

void MainWindow::paintEvent(QPaintEvent *event)
{
   glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   glTranslated(0.0, 0.0, -(farVal - 2.0));

   glRotatef(30, 1.0f, 1.0f, 1.0f);

   glBegin(GL_POLYGON);
       glColor3f(0.0,  1.0, 0.0);
       glVertex3f(0.5, -0.5, 0.5);
       glVertex3f(0.5, 0.5, 0.5);
       glVertex3f(-0.5, 0.5, 0.5);
       glVertex3f(-0.5, -0.5, 0.5);
   glEnd();

   glBegin(GL_POLYGON);
       glColor3f(1.0, 0.0, 0.0);
       glVertex3f(-0.5, -0.5, 0.5);
       glVertex3f(-0.5, 0.5, 0.5);
       glVertex3f(-0.5, 0.5, -0.5);
       glVertex3f(-0.5, -0.5, -0.5);
   glEnd();

   glBegin(GL_POLYGON);
       glColor3f(0.0, 0.0, 1.0);
       glVertex3f(0.5, 0.5, 0.5);
       glVertex3f(0.5, 0.5, -0.5);
       glVertex3f(-0.5, 0.5, -0.5);
       glVertex3f(-0.5, 0.5, 0.5);
   glEnd();

   glFlush();
}
